/* Copyright (C) 2001 W.P. van Paassen - peter@paassen.tmfweb.nl, E.C. Brummel
   

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

//***************************************************************************
//***                       CLASS GAMEFRAME                               ***
//***************************************************************************

import java.applet.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;

public class GameFrame extends Applet
{
    private Spel spel;
    private SpeelVeldPanel svp;
	private Thread userInterface;

    public static Image[] cards; 
    public static Image[] backgrounds;
    public static Image[] cardTops;
    
    //CONSTRUCTOR
    public void init()
	{        		
		int aantalKaarten = 52;
        KaartStapel kaartStapel = new KaartStapel(aantalKaarten);
   	    spel = new Spel(kaartStapel.getKaartenRij(), 4, 4, 8);
        
        //ALLE KAARTEN INLEZEN EN IN EEN RIJ ZETTEN ZODAT DE IMAGES GELIJK BESCHIKBAAR ZIJN
        cards = new Image[aantalKaarten];
        for (int i = 0; i < aantalKaarten; i++)
		{
			String fileName = "" + Integer.toString(i+1) + ".gif";
            cards[i] = loadImageFromJar(fileName);
						
			MediaTracker tracker = new MediaTracker(this);
			tracker.addImage(cards[i], i);
			try
			{
                   tracker.waitForAll();
			}
			catch (InterruptedException e){}
        }
        
        //ALLE ACHTERGRONDEN INLEZEN EN IN EEN RIJ ZETTEN ZODAT DE IMAGES GELIJK BESCHIKBAAR ZIJN
        backgrounds = new Image[7];
        backgrounds[0] = loadImageFromJar("f.gif");    
        backgrounds[1] = loadImageFromJar("r.gif");    
        backgrounds[2] = loadImageFromJar("e.gif");    
        backgrounds[3] = loadImageFromJar("c.gif");    
        backgrounds[4] = loadImageFromJar("l.gif");
        backgrounds[5] = loadImageFromJar("head1.gif");
        backgrounds[6] = loadImageFromJar("head2.gif");

        //ALLE BOVENKANTJES (20 HOOG) VAN DE KAARTEN IN EEN RIJ ZETTEN
        //DOOR ALLE KAARTEN TE 'CROPPEN'
        cardTops = new Image[52];
        for (int i = 0; i < 52; i++){
            ImageProducer prod = cards[i].getSource();
            ImageFilter filter = new CropImageFilter(0,0,71,20);
            ImageProducer filterProd = new FilteredImageSource(prod,filter);
            cardTops[i] = createImage(filterProd);
            MediaTracker tracker = new MediaTracker(this);
            tracker.addImage(cardTops[i], i);
            try{
                tracker.waitForAll();
            }
            catch (InterruptedException e){}
        }

        //SPEELVELDPANEL MAKEN
        int aantalFreeCells = spel.getAantalFreeCells();
        int aantalHomeCells = spel.getAantalHomeCells();
        int aantalStackCells = spel.getAantalStackCells();

        Vector[] stackCellKaarten = new Vector[aantalStackCells];
        for (int i = 0; i < aantalStackCells; i++){
            stackCellKaarten[i] = spel.getKaartenUitStackCell(i);
        }
		
		svp = new SpeelVeldPanel(aantalFreeCells, aantalHomeCells,
                                            aantalStackCells, stackCellKaarten);
        add(svp);
        //SPEL AANMELDEN BIJ SPEELVELDPANEL EN VICE VERSA
        spel.addPropertyChangeListener(svp);
        svp.addPropertyChangeListener(spel);
        svp.addVetoableChangeListener(spel);

        //SETCURSOR
        svp.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	}

	/*
	* This method replaces getImage because of the fact that NETSCAPE SUCKS and can't read images from a jar with getImage()
	*/
	public Image loadImageFromJar(String fileName)
	{
		InputStream is = this .getClass().getResourceAsStream(fileName); 
		ByteArrayOutputStream baos = new ByteArrayOutputStream(); 
		Image image;
		try 
		{ 
			int c; 
			while ( (c = is.read()) >= 0 ) 
			{ 
				baos.write(c); 
			} 
			image = getToolkit().createImage(baos .toByteArray()); 
			return image;
		} 
		catch ( IOException e ) 
		{ 
			e.printStackTrace(); 
		} 
		return null;		
	}
}
