/* Copyright (C) 2001 W.P. van Paassen - peter@paassen.tmfweb.nl, E.C. Brummel
   

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

//***************************************************************************
//***                       CLASS HOME_CELL                               ***
//***************************************************************************

public class Home_Cell extends Cell{
   
    private Kaart kaart;
   
    //METHOD getTopKaart
    public Kaart getTopKaart(){
   	    return kaart;
    }
    
    //METHOD removeTopKaart
    public void removeTopKaart(){
            if (kaart.getRang() == Kaart.Aas) kaart = null;
            else kaart = new Kaart((byte)(kaart.getRang()-1),kaart.getKaartSoort());
    }
    
    //METHOD getAantalKaarten
    public int getAantalKaarten(){
   	if (kaart == null) return 0;
      	return kaart.getRang();
    }
   
    //METHOD clonedeep
    public Cell clonedeep(){
       	Home_Cell kopie = new Home_Cell();
        kopie.kaart = kaart;
       	return kopie;
    }
   
    //METHOD equals
    public boolean equals (Cell other){
        Home_Cell homeother = (Home_Cell)other;
        return homeother.kaart == kaart;
    }
   
    //METHOD setTopKaart
    public void setTopKaart(Kaart kaart){
        this.kaart = kaart;
    }
   
    //METHOD kaartKanGeplaatstWorden
    public boolean kaartKanGeplaatstWorden(Kaart deKaart){
   	    //EEN AAS KAN IN EEN HOMECELL ALS DE CELL LEEG IS
        if (kaart == null && deKaart.getRang() == Kaart.Aas) return true;
        if(kaart == null) return false;
         
        //OF ANDERS IN EEN HOMECELL ALS DE KAARTSOORT HETZELFDE IS
        //EN DE RANG 1 HOGER IS DAN DE KAART DIE ER AL LIGT
        return deKaart.getKaartSoort() == kaart.getKaartSoort() &&
                          deKaart.isEenHogerInRangDan(kaart);
    }
    
    //METHOD bevatKaart
    public boolean bevatKaart(){
   	    return kaart != null;
    }
    
    //METHOD reset
    public void reset(){
        kaart = null;
    }
    
    //METHOD drukAf
    public void drukAf(){
   	    if (kaart == null) System.out.println("leeg");
   	    else kaart.drukAf();
    }
}
