/* Copyright (C) 2001 W.P. van Paassen - peter@paassen.tmfweb.nl, E.C. Brummel
   

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

//***************************************************************************
//***                       CLASS KAART                                   ***
//***************************************************************************

class Kaart{

    public static final byte Aas = 1;
    public static final byte Boer = 11;
    public static final byte Vrouw = 12;
    public static final byte Heer = 13;
    public static final byte Klaveren = 0;
    public static final byte Ruiten = 1;
    public static final byte Harten = 2;
    public static final byte Schoppen = 3;

    private byte rang;
    private byte kaartSoort;
   
    //CONSTRUCTOR
    public Kaart (byte rang, byte kaartSoort){
        this.rang = rang;
        this.kaartSoort = kaartSoort;
    }
   
    //METHOD getRang
    public byte getRang(){
        return rang;
    }
    
    //METHOD getKaartSoort
    public byte getKaartSoort(){
        return kaartSoort;
    }
    
    //METHOD equals
    public boolean equals(Kaart other){
    	if (other == null) return false;
    	return other.rang == rang && other.kaartSoort == kaartSoort;
    }
   
    //METHOD getKleur
    public String getKleur(){
        if (kaartSoort == Schoppen || kaartSoort == Klaveren)
            return "zwart";
        return "rood";
    }
   
    //METHOD cardToString
    public String cardToString(){
        String v;
        String s;
        if (rang == Aas) v = "Ace";
        else if (rang == Boer) v = "Jack";
        else if (rang == Vrouw) v = "Queen";
        else if (rang == Heer) v = "King";
        else v = String.valueOf(rang);
        if (kaartSoort == Harten) s = "of Hearts";
        else if (kaartSoort == Schoppen) s = "of Spades";
        else if (kaartSoort == Ruiten) s = "of Diamonds";
        else s = "of Clubs";
        return v + " " + s;
    }
    
    //METHOD isEenLagerInRangDan
    public boolean isEenLagerInRangDan(Kaart other){
    	return other.rang - rang == 1;
    }
    
    //METHOD isEenHogerInRangDan
    public boolean isEenHogerInRangDan(Kaart other){
    	return rang - other.rang == 1;
    }
    
    //METHOD heeftAndereKleurDan
    public boolean heeftAndereKleurDan(Kaart other){
    	String otherkleur = other.getKleur();
    	String kleur = getKleur();
    	return !otherkleur.equals(kleur);
    }
    
    //METHOD drukAf
    public void drukAf(){
      	System.out.println("* " +cardToString());
    }

    //METHOD getCardNumber
    public int getCardNumber(){
        return kaartSoort * 13 + rang -1;
    }
}
