/* Copyright (C) 2001 W.P. van Paassen - peter@paassen.tmfweb.nl, E.C. Brummel
   

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

//***************************************************************************
//***                       CLASS KAARTSTAPEL                             ***
//***************************************************************************

import java.lang.*;
import java.util.*;

class KaartStapel
{ 
    private int aantalKaarten;
    private Kaart[] kaartenRij;
    private boolean[] beschikbareKaarten;
   
    //CONSTRUCTOR
    public KaartStapel(int hetAantalKaarten)
	{
  	    aantalKaarten = hetAantalKaarten;
  	    kaartenRij = new Kaart[hetAantalKaarten];
   	    beschikbareKaarten = new boolean[hetAantalKaarten];
   	    maakAlleKaartenBeschikbaar();
   	    maakGeschuddeKaartStapel();
    }
           
    //METHOD maakGeschuddeKaartStapel
    private void maakGeschuddeKaartStapel(){
   	    int teller = 0;
   	    byte kaartSoortIndex = 0;
   	    byte kaartRangIndex = 1;
   	    while (teller != aantalKaarten){
   		    int randomwaarde = getRandomKaartIndex();
   		    kaartenRij[randomwaarde] = new Kaart(kaartRangIndex, kaartSoortIndex);
   		    kaartSoortIndex++;
   		    if (kaartSoortIndex == 4){
   			    kaartSoortIndex = 0;
   			    kaartRangIndex++;
            }
   	        teller++;
   	    }
    }
   
    //METHOD getNewRandomWaarde levert een unieke index waarde tussen 0 en het aantal kaarten
    private int getRandomKaartIndex(){
   	    int random = ((int)(Math.random() * 1000))%aantalKaarten;
   	    while (!beschikbareKaarten[random]) random  = ((int)(Math.random() * 1000))%aantalKaarten;
   	    beschikbareKaarten[random] = false;
   	    return random;
    }
   
    //METHOD resetRandomWaarden
    private void maakAlleKaartenBeschikbaar() {
   	    for(int i = 0; i < aantalKaarten; i++) beschikbareKaarten[i] = true;
    }
   
    //METHOD getKaartenRij
    public Kaart[] getKaartenRij(){
   	    return kaartenRij;
    }
   
    //METHOD drukAf()
    public void drukAf(){
   	    System.out.println("Aantal kaarten : " + aantalKaarten);
   	    for (int index = 0; index < aantalKaarten; index++)
   	        System.out.println(kaartenRij[index].cardToString());      
    }
}
