/* Copyright (C) 2001 W.P. van Paassen - peter@paassen.tmfweb.nl, E.C. Brummel
   

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

//***************************************************************************
//***                       CLASS SINGLECELLPANEL                         ***
//***************************************************************************

import java.awt.*;
import java.awt.event.*;

abstract class SingleCellPanel extends Panel {
    
    abstract boolean select();
    abstract boolean deselect();
    abstract void drawCell(Object object);
    abstract void setBackgroundImage(Image image);
    abstract Image getBackgroundImage();
    abstract void mouseMoved(MouseEvent evt);
    abstract void mousePressed(MouseEvent evt);
    abstract void highlightCard(byte kaartRang);

    public SingleCellPanel(){
    	addMouseListener(new MouseAdapter(){
            public void mousePressed(MouseEvent evt){
                SingleCellPanel.this.mousePressed(evt);
            }
        });
    	addMouseMotionListener(new MouseMotionAdapter(){
            public void mouseMoved(MouseEvent evt){
                SingleCellPanel.this.mouseMoved(evt);
            }
        });
    }
}
