/* Copyright (C) 2001 W.P. van Paassen - peter@paassen.tmfweb.nl, E.C. Brummel
   

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

//***************************************************************************
//***                       CLASS SINGLESTACKCELLPANEL                    ***
//***************************************************************************

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;

class SingleStackCellPanel extends SingleCellPanel {
    
    private int ID;
    private boolean selected;
    private Vector kaarten;
    private int tempPos;
    private PropertyChangeSupport pcs = new PropertyChangeSupport(this);
    
    //CONSTRUCTOR
    public SingleStackCellPanel(int ID){
        this.ID = ID;
    }
    
    //METHOD setBackgroundImage
    public void setBackgroundImage(Image image){
        //dummy
    }
    
    //METHOD getBackgroundImage
    public Image getBackgroundImage(){
        return null;
    }

    //METHOD paint
    public void paint(Graphics g){
        g.fill3DRect(0, 0, 77, 440, true);
        int aantalKaarten = kaarten.size();
        if (aantalKaarten !=0){
            int yPos = 0;
            Image buffer = createImage(71, ((aantalKaarten-1)*20)+96);
            Graphics bg = buffer.getGraphics();
            for (int i = aantalKaarten; i > 1 ; i--){
                Kaart kaart = (Kaart)kaarten.elementAt(i-1);
                Image card = GameFrame.cardTops[kaart.getCardNumber()];
                bg.drawImage(card, 0, yPos, 71, 20, null);
                yPos+=20;
            }
            Kaart kaart = (Kaart)kaarten.elementAt(0);
            Image card = GameFrame.cards[kaart.getCardNumber()];
            bg.drawImage(card, 0, yPos, 71, 96, null);
            yPos+=20;
            tempPos = yPos;
            g.drawImage(buffer, 3, 2, this);
            bg.dispose();
            if (selected){
                g.setXORMode(new Color(255, 79, 196));
                g.fillRect(4, (tempPos-17), 69, 94);
            }
        }
    }
    
    //METHOD drawCell
    public void drawCell(Object object){
        kaarten = (Vector) object;
        repaint();
    }

    //METHOD highlightCard
    public void highlightCard(byte kaartRang){
        int aantalKaarten = kaarten.size();
        for (int i = 0 ; i < aantalKaarten; i++){
            Kaart kaart = (Kaart)kaarten.elementAt(i);
            if (i == 0 && !selected && kaart.getRang() == kaartRang){
                Graphics g = getGraphics();
                g.setXORMode(new Color(255, 79, 196));
                g.fillRect(4, tempPos-17, 69, 94);
            }
            else if (kaart.getRang() == kaartRang){
                Graphics g = getGraphics();
                g.setXORMode(new Color(255, 79, 196));
                g.fillRect(4, tempPos - 17 - (i * 20), 69, 20);
            }
        }
    }

    //METHOD drukAf()
    public void drukAf(){
   	System.out.println("StackCell " +ID +" bevat: ");
        int index = 0;
        while(index < kaarten.size()){
            Kaart kaart = (Kaart)kaarten.elementAt(index);
            kaart.drukAf();
            index++;
        }
    }

    //METHOD select
    public boolean select(){
        if (!kaarten.isEmpty()){
            selected = true;
            Graphics g = getGraphics();
            g.setXORMode(new Color(255, 79, 196));
            g.fillRect(4, tempPos-17, 69, 94);
        }
        return selected;
    }
    
    //METHOD deselect
    public boolean deselect(){
        if (selected){
            Graphics g = getGraphics();
            g.setXORMode(new Color(255, 79, 196));
            g.fillRect(4, tempPos-17, 69, 94);
        }
        selected = false;
        return selected;
    }
    
    //METHOD getPreferredSize
    public Dimension getPreferredSize(){ return new Dimension(77, 440); }
    
    //METHOD mousePressed
    public void mousePressed(MouseEvent evt){
		int y = evt.getY();
		int kaartnummer;
			
		if (kaarten.size() > 0)
		{
			if (y >= (kaarten.size() - 1) * 20)
				kaartnummer = kaarten.size() - 1;
			else
				kaartnummer = y/20;
	/*
	            Graphics g = getGraphics();
	            g.setXORMode(new Color(255, 79, 196));
	            g.fillRect(4, (kaartnummer * 20 + 3), 69, 20);
	*/
	         Kaart kaart = (Kaart)kaarten.elementAt(kaarten.size() - 1 - kaartnummer);
	         String kaartNaam = kaart.cardToString();
	         pcs.firePropertyChange("rightMouseClick", kaartNaam, null);
	/*            try{
	                Thread.sleep(200);
	            }
	            catch(InterruptedException e){}
	            g.setXORMode(new Color(255, 79, 196));
	            g.fillRect(4, (kaartnummer * 20 + 3), 69, 20);
*/		}
		pcs.firePropertyChange("clicked", null, new Integer(ID));
    }
          
    //METHOD mouseMoved
    public void mouseMoved(MouseEvent evt){
        pcs.firePropertyChange("Kupke",new Integer(ID),null);
    }
	
	//METHOD addPropertyChangeListener
    public void addPropertyChangeListener(PropertyChangeListener l){
        pcs.addPropertyChangeListener(l);
    }
	
	//METHOD removePropertyChangeListener
    public void removePropertyChangeListener(PropertyChangeListener l){
        pcs.removePropertyChangeListener(l);
    }
    
}
