/* Copyright (C) 2001 W.P. van Paassen - peter@paassen.tmfweb.nl, E.C. Brummel
   

   This program is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

//***************************************************************************
//***                       CLASS STACK_CELL                              ***
//***************************************************************************

import java.util.*;

public class Stack_Cell extends Cell{

    private Vector kaarten;
    
    //CONSTRUCTOR
    public Stack_Cell(){
   	    kaarten = new Vector();
    }
    
    //METHOD getTopKaart
    public Kaart getTopKaart(){
   	    if (bevatKaart()) return (Kaart) kaarten.firstElement();
   		    return null;
    }
   
    //METHOD removeTopKaart
    public void removeTopKaart(){
    	kaarten.removeElement(kaarten.firstElement());
    }
   
    //METHOD equals
    public boolean equals(Cell other){
   	Stack_Cell stackother = (Stack_Cell)other;     
      	if (stackother.kaarten.size() != kaarten.size()) return false;           

      	Enumeration enum = kaarten.elements();
      	Enumeration otherenum = stackother.kaarten.elements();             
      	while(enum.hasMoreElements()){
               if (enum.nextElement() != otherenum.nextElement()) return false;
      	}      
      	return true;    
    }
    
    //METHOD getKaarten
    public Vector getKaarten(){
        return kaarten;
    }
    
    //METHOD getAantalKaarten
    public int getAantalKaarten(){
   	    return kaarten.size();
    }
    
    //METHOD setTopKaart
    public void setTopKaart(Kaart kaart){
   	    kaarten.insertElementAt(kaart,0);
    }
   
    //METHOD kaartKanGeplaatstWorden
    public boolean kaartKanGeplaatstWorden(Kaart deKaart){
        //ALS DE STACKCELL GEEN KAART BEVAT MOGEN ALLE KAARTEN GEPLAATST WORDEN
        //ALS DE STACKCELL EEN KAART BEVAT MOET DE KLEUR VAN DE KAARTEN
        //HETZELFDE ZIJN EN DE KAART MOET 1 LAGER IN RANG ZIJN DAN
        //DE KAART DIE ER AL LIGT.
        
        if (kaarten.isEmpty()) return true;
        if (deKaart == null) return false;
        Kaart topKaart = (Kaart) kaarten.firstElement();
        	return deKaart.heeftAndereKleurDan(topKaart) &&
   				deKaart.isEenLagerInRangDan(topKaart);
    }
    
    //METHOD clonedeep
    public Cell clonedeep(){
   	Stack_Cell kopie = new Stack_Cell();
      
      	Enumeration enum = kaarten.elements();      
      	while(enum.hasMoreElements()){
               kopie.kaarten.addElement(enum.nextElement());
      	}
      	return kopie;
    }
    
    //METHOD bevatKaart
    public boolean bevatKaart(){
        return !kaarten.isEmpty();
    }
    
    //METHOD reset
    public void reset(){
   	    kaarten = new Vector();
   	}
    
    //METHOD drukAf()
    public void drukAf(){
   	    if (kaarten.isEmpty()) System.out.println("Leeg!");
        else{
        	Enumeration enum = kaarten.elements();
        	while(enum.hasMoreElements()){
           		Kaart kaart = (Kaart) enum.nextElement();
           		kaart.drukAf();
        	}
   	    }
    }
}
